diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index adf316453..934ff1da9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -374,6 +374,11 @@ public class GameWindowGLFW implements GameWindow {
         }
     }
 
+    @Override
+    public long getHandle() {
+        return this.window;
+    }
+
     public static class MonitorInfo {
 
         public final long handle;
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/FileOpener.java b/game/client/src/main/java/net/minecraft/client/util/helper/FileOpener.java
new file mode 100644
index 000000000..a78193085
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/FileOpener.java
@@ -0,0 +1,88 @@
+package net.minecraft.client.util.helper;
+
+import java.awt.Desktop;
+import java.io.File;
+import java.io.IOException;
+import java.util.Locale;
+
+public final class FileOpener {
+
+    public static boolean toClipboard(String path) {
+        String os = System.getProperty("os.name").toLowerCase(Locale.ROOT);
+
+        if (os.contains("win")) {
+            return (run("powershell", "-Command %s", "Get-ChildItem \"" + path + "\" | Set-Clipboard"));
+        }
+
+        if (os.contains("mac")) {
+            return (run("osascript", "-e %s", "set the clipboard to (read (POSIX file \"" + path + "\") as {«class PNGf»})"));
+        }
+
+        return run("xclip-copyfile", "%s", path);
+    }
+
+    public static void open(File file) {
+
+        if (!openSystem(file.getPath()) && !openDESKTOP(file))
+            System.err.println("unable to open file " + System.getProperty("os.name"));
+    }
+
+    private static boolean openSystem(String what) {
+
+        String os = System.getProperty("os.name").toLowerCase(Locale.ROOT);
+
+        if (os.contains("win")) {
+            return (run("explorer", "%s", what));
+        }
+
+        if (os.contains("mac")) {
+            return (run("open", "%s", what));
+        }
+
+        return run("kde-open", "%s", what) || run("gnome-open", "%s", what) || run("xdg-open", "%s", what);
+
+    }
+
+    private static boolean openDESKTOP(File file) {
+
+        if (Desktop.isDesktopSupported() && Desktop.getDesktop().isSupported(Desktop.Action.OPEN)) {
+            try {
+                Desktop.getDesktop().open(file);
+                return true;
+            } catch (IOException e) {
+                e.printStackTrace();
+            }
+        }
+        return false;
+
+    }
+
+    private static boolean run(String command, String arg, String file) {
+
+        String[] args = arg.split(" ");
+        String[] parts = new String[args.length + 1];
+        parts[0] = command;
+        for (int i = 0; i < args.length; i++) {
+            parts[i + 1] = String.format(args[i], file).trim();
+        }
+
+        System.out.println(String.join(" ", parts));
+
+        try {
+            Process p = Runtime.getRuntime().exec(parts);
+            if (p == null)
+                return false;
+
+            try {
+                if (p.exitValue() == 0)
+                    return true;
+                return false;
+            } catch (IllegalThreadStateException itse) {
+                return true;
+            }
+        } catch (IOException e) {
+            //e.printStackTrace();
+            return false;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 6b41dc830..2127c1808 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -96,7 +96,7 @@ public class ItemDragHandler extends Gui {
 		}
 		
 		if(slot.mayPlace(draggingItemStack) && slot.enableDragAndPickup()) {
-			if(slot.getItem() == null || slot.getItem().canStackWith(draggingItemStack)) {
+			if(slot.getItemStack() == null || slot.getItemStack().canStackWith(draggingItemStack)) {
 				if(!draggedSlots.contains(slot)) {
 					draggedSlots.add(slot);
 				}
@@ -108,7 +108,7 @@ public class ItemDragHandler extends Gui {
 		if(slot == null) throw new NullPointerException("Slot is null");
 		if(draggingItemStack == null) throw new NullPointerException("Stack is null!");
 
-		ItemStack stack = slot.getItem();
+		ItemStack stack = slot.getItemStack();
 		
 		glDisable(GL_TEXTURE_2D);
 		glEnable(GL_BLEND);
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
index 6dbaa8add..a3ac8a4b9 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.util.helper;
 
-import java.awt.image.BufferedImage;
+import java.awt.image.*;
 import java.io.File;
 import java.nio.ByteBuffer;
+import java.nio.IntBuffer;
+import java.nio.ShortBuffer;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Date;
@@ -10,7 +12,10 @@ import java.util.Date;
 import javax.imageio.ImageIO;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
 import org.lwjgl.BufferUtils;
+import org.lwjgl.glfw.GLFW;
+import org.lwjgl.opengl.AMDInterleavedElements;
 import org.lwjgl.opengl.GL11;
 
 import com.b100.utils.ImageUtils;
@@ -60,11 +65,14 @@ public class ScreenShot
             BufferedImage bufferedimage = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
             bufferedimage.setRGB(0, 0, width, height, imageData, 0, width);
             ImageIO.write(bufferedimage, "png", destFile);
+            boolean copiedImage = false;
             try {
-            	ImageUtils.copyImageToClipboard(bufferedimage);
-            }catch (Exception e) {
-                LOGGER.error("Exception copying image to clipboard!", e);
-			}
+                copiedImage = FileOpener.toClipboard(destFile.getAbsolutePath());
+            } catch (Exception ignored) {
+            }
+            if (copiedImage) {
+                return "Saved screenshot as " + destFile.getName() + " and copied to clipboard.";
+            }
             return "Saved screenshot as " + destFile.getName();
         }
         catch(Exception exception)
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index 278518b1a..7cc5cfa4b 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -57,6 +57,7 @@ public class ChunkProviderClient
     public Chunk prepareChunk(int chunkX, int chunkZ)
     {
         ChunkCoordinate chunkcoordintpair = new ChunkCoordinate(chunkX, chunkZ);
+        if (chunkMapping.containsKey(chunkcoordintpair)) return chunkMapping.get(chunkcoordintpair);
         Chunk chunk = new Chunk(worldObj, chunkX, chunkZ);
         chunkMapping.put(chunkcoordintpair, chunk);
         chunk.isLoaded = true;
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/battle_ui/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/comfy/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/creep-o-vision/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/border.png.mcmeta
new file mode 100644
index 000000000..2f4038c66
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/border.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border":  {
+                "left": 9,
+                "top": 8,
+                "right": 8,
+                "bottom": 8
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/crt/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/default/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/detailed/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/interdimensional/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/border.png.mcmeta
new file mode 100644
index 000000000..28c610590
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 2
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/modern/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/noteblock/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/border.png.mcmeta
new file mode 100644
index 000000000..c185504b7
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 24,
+            "height": 24,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/picnic/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/planks/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/border.png.mcmeta
new file mode 100644
index 000000000..a44b677e1
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 14,
+            "height": 14,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/redstone_goggles/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/border.png.mcmeta
new file mode 100644
index 000000000..a44b677e1
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 14,
+            "height": 14,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/retro/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/rpg/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/border.png.mcmeta
new file mode 100644
index 000000000..3e3e52985
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 25,
+            "height": 25,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/steve/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/border.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/border.png.mcmeta
new file mode 100644
index 000000000..a44b677e1
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/border.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 14,
+            "height": 14,
+            "border": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/inner.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/inner.png.mcmeta
new file mode 100644
index 000000000..a54149394
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/gui/sprites/tooltip/stone/inner.png.mcmeta
@@ -0,0 +1,9 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "tile",
+            "width": 8,
+            "height": 8
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/com/b100/utils/ImageUtils.java b/game/core/src/main/java/com/b100/utils/ImageUtils.java
index 6a436f00f..aff20192a 100644
--- a/game/core/src/main/java/com/b100/utils/ImageUtils.java
+++ b/game/core/src/main/java/com/b100/utils/ImageUtils.java
@@ -3,7 +3,6 @@ package com.b100.utils;
 import static com.b100.utils.Utils.*;
 
 import java.awt.Image;
-import java.awt.Toolkit;
 import java.awt.datatransfer.DataFlavor;
 import java.awt.datatransfer.Transferable;
 import java.awt.datatransfer.UnsupportedFlavorException;
@@ -16,11 +15,7 @@ import java.nio.file.Files;
 import javax.imageio.ImageIO;
 
 public abstract class ImageUtils {
-	
-	public static void copyImageToClipboard(BufferedImage image) {
-		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new TransferableImage(image), null);
-	}
-	
+
 	public static BufferedImage loadExternalImage(String path) {
 		return loadExternalImage(new File(path));
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java b/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
index cf3160a9b..3cda4836e 100644
--- a/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
+++ b/game/core/src/main/java/net/minecraft/core/MinecraftAccessor.java
@@ -28,4 +28,8 @@ public interface MinecraftAccessor
     default Collection<String> getAvailableSoundKeys() {
         return SoundTypes.getSoundIds().values();
     }
+
+    default void copyToClipboard(String str) { }
+
+    default String readFromClipboard() { return ""; }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index cfa71e5c2..80597d2b7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -81,9 +81,9 @@ public class BlockLogicActivator extends BlockLogicVeryRotatable
         if(flag && (meta & MASK_POWERED) == 0)
         {
             world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
-            world.setBlockMetadata(x, y, z, meta | MASK_POWERED);
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
         } else if (!flag){
-            world.setBlockMetadata(x, y, z, meta & ~MASK_POWERED);
+            world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 31cb0d1ab..c7129397e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -793,7 +793,7 @@ public final class Blocks {
     public static final Block<BlockLogicPistonBase> PISTON_BASE_STICKY = register("piston.base.sticky", "minecraft:block/piston_base_sticky", 521, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBaseSticky(b, 12))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<BlockLogicPistonHead> PISTON_HEAD = register("piston.head", "minecraft:block/piston_head", 522, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 4/16d))
+    public static final Block<BlockLogicPistonHead> PISTON_HEAD = register("piston.head", "minecraft:block/piston_head", 522, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 4/16d, 4/16d))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block<BlockLogicPistonMoving> PISTON_MOVING = register("piston.moving", "minecraft:block/piston_moving", 523, BlockLogicPistonMoving::new)
@@ -802,7 +802,7 @@ public final class Blocks {
     public static final Block<BlockLogicPistonBase> PISTON_BASE_STEEL = register("piston.base.steel", "minecraft:block/piston_base_steel", 524, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBaseSteel(b, 24))
         .withSound(BlockSounds.METAL).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<BlockLogicPistonHead> PISTON_HEAD_STEEL = register("piston.head.steel", "minecraft:block/piston_head_steel", 525, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 6/16d))
+    public static final Block<BlockLogicPistonHead> PISTON_HEAD_STEEL = register("piston.head.steel", "minecraft:block/piston_head_steel", 525, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 6/16d, 8/16d))
         .withSound(BlockSounds.METAL).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
